format compact
clear all
close all


rsmall=.3255;
rlarge=.753;



global t_ ts_ tss_ dx_ dy_ mp_ r0_



load m11.txt
load m12.txt
load m13.txt
load m14.txt


% input file structure:
% 1    2   3 4 5 6
% No. time X x Y y
%
% X,Y - position of the end of long bar (yellow)
% x,y - position of the end of short bar (blue)


% trajectories for small bar


y1=m11;
y2=m12;
y3=m13;
y4=m14;

figure ('position', [70 420 400 300])
plot(y1(:,4),y1(:,6),'y',y1(:,3),y1(:,5),'c')
grid
xlabel('\Delta x [m]')
ylabel('\Delta y [m]')
set(gca,'color',[.8 .8 .8]);
%pause

figure ('position', [540 420 400 300])
plot(y2(:,4),y2(:,6),'r',y2(:,3),y2(:,5),'c')
grid
xlabel('\Delta x [m]')
ylabel('\Delta y [m]')
set(gca,'color',[.8 .8 .8]);
%pause

figure ('position', [70 30 400 300])
plot(y3(:,4),y3(:,6),'b',y3(:,3),y3(:,5),'c')
grid
xlabel('\Delta x [m]')
ylabel('\Delta y [m]')
set(gca,'color',[.8 .8 .8]);
%pause

figure ('position', [540 30 400 300])
plot(y4(:,4),y4(:,6),'m',y4(:,3),y4(:,5),'c')
grid
xlabel('\Delta x [m]')
ylabel('\Delta y [m]')
set(gca,'color',[.8 .8 .8]);
pause








%x1=[1:1:100]';
%x2=linspace(0,2*pi)';
%x3=0*ones(size(x2));
%x4=cos(x2);
%x5=0*ones(size(x2));
%x6=sin(x2);
%
%xxx=[x1 x2 x3 x4 x5 x6];











%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      drawing the y and Y coordinates & FFT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%
% measurement No. 1
%%%%%%%%%%%%%%%%%%%%
r0=rsmall;
r=y1;
t=r(:,2);
[mp,np]=size(r);
ts=r(1:mp-1,2);
tsm=[0 ts'+.015]';
mp=mp-1;
tss=r(1:mp-1,2);


y=interp1(tsm,[r(1,6) r(1:mp,6)']',ts);
yy=r(1:mp,5);
dy=y-yy;
x=r(:,4);
x=interp1(tsm,[r(1,4) r(1:mp,4)']',ts);
xx=r(1:mp,3);
dx=x-xx;

figure ('position', [85 410 400 300])
plot(ts,dy,'r',t,r(:,5),'r:')
grid
xlabel('time [s]')
ylabel('\Delta y & Y [m]')
set(gca,'color',[.8 .8 .8]);
%pause




% FFT
[mp,np]=size(r);
fdt=r(2,2)-r(1,2);
fy=fft(r(:,4),mp);
pyy=2*sqrt(fy.*conj(fy))/mp;
mpyy=max(pyy);
ff=1/fdt/mp*(0:floor(mp/2)-1);

[mp1,np]=size(dy);
ffdt=r(2,2)-r(1,2);
ffy=fft(dy,mp1);
fpyy=2*sqrt(ffy.*conj(ffy))/mp1;
mfpyy=max(fpyy);
fff=1/ffdt/mp1*(0:floor(mp1/2)-1);



figure ('position', [525 410 400 300])
plot(ff,pyy(1:floor(mp/2))/mpyy,'r:',fff,fpyy(1:floor(mp1/2))/mfpyy,'r')
grid
axis([0 6 0 1.2])
xlabel('f [Hz]')
ylabel('Amplitude')
set(gca,'color',[.8 .8 .8]);
%pause


%%%%%%%%%%%%%%%%%%%%
% measurement No. 2
%%%%%%%%%%%%%%%%%%%%
r0=rsmall;
r=y2;
t=r(:,2);
[mp,np]=size(r);
ts=r(1:mp-1,2);
tsm=[0 ts'+.015]';
mp=mp-1;
tss=r(1:mp-1,2);


y=interp1(tsm,[r(1,6) r(1:mp,6)']',ts);
yy=r(1:mp,5);
dy=y-yy;
x=r(:,4);
x=interp1(tsm,[r(1,4) r(1:mp,4)']',ts);
xx=r(1:mp,3);
dx=x-xx;

figure ('position', [85 40 400 300])
plot(ts,dy,'b',t,r(:,5),'b:')
grid
xlabel('time [s]')
ylabel('\Delta y & Y [m]')
set(gca,'color',[.8 .8 .8]);
%pause




% FFT
[mp,np]=size(r);
fdt=r(2,2)-r(1,2);
fy=fft(r(:,4),mp);
pyy=2*sqrt(fy.*conj(fy))/mp;
mpyy=max(pyy);
ff=1/fdt/mp*(0:floor(mp/2)-1);

[mp1,np]=size(dy);
ffdt=r(2,2)-r(1,2);
ffy=fft(dy,mp1);
fpyy=2*sqrt(ffy.*conj(ffy))/mp1;
mfpyy=max(fpyy);
fff=1/ffdt/mp1*(0:floor(mp1/2)-1);



figure ('position', [525 40 400 300])
plot(ff,pyy(1:floor(mp/2))/mpyy,'b:',fff,fpyy(1:floor(mp1/2))/mfpyy,'b')
grid
axis([0 6 0 1.2])
xlabel('f [Hz]')
ylabel('Amplitude')
set(gca,'color',[.8 .8 .8]);
pause

















%%%%%%%%%%%%%%%%% ROTATION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% Measurement No. 1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

r=m11;


[mp,np]=size(r)


%************* small bar *********************


r0=rsmall;
t=r(:,2);
ts=r(1:mp-1,2);
tsm=[0 ts'+.015]';
mp=mp-1;
tss=r(1:mp-1,2);


y=interp1(tsm,[r(1,6) r(1:mp,6)']',ts);
yy=r(1:mp,5);
dy=y-yy;
x=r(:,4);
x=interp1(tsm,[r(1,4) r(1:mp,4)']',ts);
xx=r(1:mp,3);
dx=x-xx;


t_=t;
ts_=ts;
tss_=tss;
dx_=dx;
dy_=dy;
mp_=mp;
r0_=r0;

% calculation of angular velocity

omega=omeg;


figure ('position', [100 400 400 300])
plot(omega(:,1),omega(:,2),'y')
grid
xlabel('time [s]')
ylabel('\omega [rad/s]')
set(gca,'color',[.8 .8 .8]);
hold
%pause


% calculation of angle: phi = integral omega*dt
[mo,no]=size(omega);
%for j=1:mo-1,
%zze(j)=trap(omega(1:j,1),omega(1:j,2));
%end
%figure
%plot(omega(1:mo-1),zze)

%%pause


zmax=trap(omega(:,1),omega(:,2));
fz=flipud(omega(:,2));
tz=flipud(omega(:,1));
zz(1)=zmax;
for j=2:mo-1
zz(j)=zz(j-1)-(fz(j-1)+fz(j))*(tz(j-1)-tz(j))/2;
end
sss=fliplr(zz);
ccc=[0 sss(1:mo-2)];


%figure
%plot(omega(1:mo-1),zze,omega(1:mo-1),ccc,'r')



figure ('position', [510 400 400 300])
plot(omega(1:mo-1,1),ccc,'y')
grid
xlabel('time [s]')
ylabel('\phi [rad]')
set(gca,'color',[.8 .8 .8]);
hold
%pause







%************* large bar *********************
r0=rlarge;
dy=yy;
dx=xx;


t_=t;
ts_=ts;
tss_=tss;
dx_=dx;
dy_=dy;
mp_=mp;
r0_=r0;

% calculation of angular velocity

omega=omeg;


figure ('position', [100 50 400 300])
plot(omega(:,1),omega(:,2),'y')
grid
xlabel('time [s]')
ylabel('\Omega [rad/s]')
set(gca,'color',[.8 .8 .8]);
hold
%pause


% calculation of angle: phi = integral omega*dt
[mo,no]=size(omega);
%for j=1:mo-1,
%zze(j)=trap(omega(1:j,1),omega(1:j,2));
%end
%figure
%plot(omega(1:mo-1),zze)

%%pause


zmax=trap(omega(:,1),omega(:,2));
fz=flipud(omega(:,2));
tz=flipud(omega(:,1));
zz(1)=zmax;
for j=2:mo-1
zz(j)=zz(j-1)-(fz(j-1)+fz(j))*(tz(j-1)-tz(j))/2;
end
sss=fliplr(zz);
ccc=[0 sss(1:mo-2)];


%figure
%plot(omega(1:mo-1),zze,omega(1:mo-1),ccc,'y')



figure ('position', [510 50 400 300])
plot(omega(1:mo-1,1),ccc,'y')
grid
xlabel('time [s]')
ylabel('\Phi [rad]')
set(gca,'color',[.8 .8 .8]);
hold
%pause



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%












% Measurement No. 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

r=m12;


[mp,np]=size(r)


%************* small bar *********************

r0=rsmall;
t=r(:,2);
ts=r(1:mp-1,2);
tsm=[0 ts'+.015]';
mp=mp-1;
tss=r(1:mp-1,2);


y=interp1(tsm,[r(1,6) r(1:mp,6)']',ts);
yy=r(1:mp,5);
dy=y-yy;
x=r(:,4);
x=interp1(tsm,[r(1,4) r(1:mp,4)']',ts);
xx=r(1:mp,3);
dx=x-xx;


t_=t;
ts_=ts;
tss_=tss;
dx_=dx;
dy_=dy;
mp_=mp;
r0_=r0;

% calculation of angular velocity

omega=omeg;


figure(9)
plot(omega(:,1),omega(:,2),'r')
%pause


% calculation of angle: phi = integral omega*dt
[mo,no]=size(omega);
%for j=1:mo-1,
%zze(j)=trap(omega(1:j,1),omega(1:j,2));
%end
%figure
%plot(omega(1:mo-1),zze)

%%pause


zmax=trap(omega(:,1),omega(:,2));
fz=flipud(omega(:,2));
tz=flipud(omega(:,1));
zz(1)=zmax;
for j=2:mo-1
zz(j)=zz(j-1)-(fz(j-1)+fz(j))*(tz(j-1)-tz(j))/2;
end
sss=fliplr(zz);
ccc=[0 sss(1:mo-2)];


%figure
%plot(omega(1:mo-1),zze,omega(1:mo-1),ccc,'r')



figure(10)
plot(omega(1:mo-1,1),ccc,'r')
%pause







%************* large bar *********************
r0=rlarge;
dy=yy;
dx=xx;


t_=t;
ts_=ts;
tss_=tss;
dx_=dx;
dy_=dy;
mp_=mp;
r0_=r0;

% calculation of angular velocity

omega=omeg;


figure(11)
plot(omega(:,1),omega(:,2),'r')
%pause


% calculation of angle: phi = integral omega*dt
[mo,no]=size(omega);
%for j=1:mo-1,
%zze(j)=trap(omega(1:j,1),omega(1:j,2));
%end
%figure
%plot(omega(1:mo-1),zze)

%%pause


zmax=trap(omega(:,1),omega(:,2));
fz=flipud(omega(:,2));
tz=flipud(omega(:,1));
zz(1)=zmax;
for j=2:mo-1
zz(j)=zz(j-1)-(fz(j-1)+fz(j))*(tz(j-1)-tz(j))/2;
end
sss=fliplr(zz);
ccc=[0 sss(1:mo-2)];


%figure
%plot(omega(1:mo-1),zze,omega(1:mo-1),ccc,'r')



figure(12)
plot(omega(1:mo-1,1),ccc,'r')
%pause



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%












% Measurement No. 3 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

r=m13;


[mp,np]=size(r)


%************* small bar *********************

r0=rsmall;
t=r(:,2);
ts=r(1:mp-1,2);
tsm=[0 ts'+.015]';
mp=mp-1;
tss=r(1:mp-1,2);


y=interp1(tsm,[r(1,6) r(1:mp,6)']',ts);
yy=r(1:mp,5);
dy=y-yy;
x=r(:,4);
x=interp1(tsm,[r(1,4) r(1:mp,4)']',ts);
xx=r(1:mp,3);
dx=x-xx;


t_=t;
ts_=ts;
tss_=tss;
dx_=dx;
dy_=dy;
mp_=mp;
r0_=r0;

% calculation of angular velocity

omega=omeg;


figure(9)
plot(omega(:,1),omega(:,2),'b')
%pause


% calculation of angle: phi = integral omega*dt
[mo,no]=size(omega);
%for j=1:mo-1,
%zze(j)=trap(omega(1:j,1),omega(1:j,2));
%end
%figure
%plot(omega(1:mo-1),zze)

%%pause


zmax=trap(omega(:,1),omega(:,2));
fz=flipud(omega(:,2));
tz=flipud(omega(:,1));
zz(1)=zmax;
for j=2:mo-1
zz(j)=zz(j-1)-(fz(j-1)+fz(j))*(tz(j-1)-tz(j))/2;
end
sss=fliplr(zz);
ccc=[0 sss(1:mo-2)];


%figure
%plot(omega(1:mo-1),zze,omega(1:mo-1),ccc,'r')



figure(10)
plot(omega(1:mo-1,1),ccc,'b')
%pause







%************* large bar *********************
r0=rlarge;
dy=yy;
dx=xx;


t_=t;
ts_=ts;
tss_=tss;
dx_=dx;
dy_=dy;
mp_=mp;
r0_=r0;

% calculation of angular velocity

omega=omeg;


figure(11)
plot(omega(:,1),omega(:,2),'b')
%pause


% calculation of angle: phi = integral omega*dt
[mo,no]=size(omega);
%for j=1:mo-1,
%zze(j)=trap(omega(1:j,1),omega(1:j,2));
%end
%figure
%plot(omega(1:mo-1),zze)

%%pause


zmax=trap(omega(:,1),omega(:,2));
fz=flipud(omega(:,2));
tz=flipud(omega(:,1));
zz(1)=zmax;
for j=2:mo-1
zz(j)=zz(j-1)-(fz(j-1)+fz(j))*(tz(j-1)-tz(j))/2;
end
sss=fliplr(zz);
ccc=[0 sss(1:mo-2)];


%figure
%plot(omega(1:mo-1),zze,omega(1:mo-1),ccc,'r')



figure(12)
plot(omega(1:mo-1,1),ccc,'b')
%pause



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%













% Measurement No. 4 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

r=m14;


[mp,np]=size(r)


%************* small bar *********************

r0=rsmall;
t=r(:,2);
ts=r(1:mp-1,2);
tsm=[0 ts'+.015]';
mp=mp-1;
tss=r(1:mp-1,2);


y=interp1(tsm,[r(1,6) r(1:mp,6)']',ts);
yy=r(1:mp,5);
dy=y-yy;
x=r(:,4);
x=interp1(tsm,[r(1,4) r(1:mp,4)']',ts);
xx=r(1:mp,3);
dx=x-xx;


t_=t;
ts_=ts;
tss_=tss;
dx_=dx;
dy_=dy;
mp_=mp;
r0_=r0;

% calculation of angular velocity

omega=omeg;


figure(9)
plot(omega(:,1),omega(:,2),'m')
%pause


% calculation of angle: phi = integral omega*dt
[mo,no]=size(omega);
%for j=1:mo-1,
%zze(j)=trap(omega(1:j,1),omega(1:j,2));
%end
%figure
%plot(omega(1:mo-1),zze)

%%pause


zmax=trap(omega(:,1),omega(:,2));
fz=flipud(omega(:,2));
tz=flipud(omega(:,1));
zz(1)=zmax;
for j=2:mo-1
zz(j)=zz(j-1)-(fz(j-1)+fz(j))*(tz(j-1)-tz(j))/2;
end
sss=fliplr(zz);
ccc=[0 sss(1:mo-2)];


%figure
%plot(omega(1:mo-1),zze,omega(1:mo-1),ccc,'r')



figure(10)
plot(omega(1:mo-1,1),ccc,'m')
%pause







%************* large bar *********************
r0=rlarge;
dy=yy;
dx=xx;


t_=t;
ts_=ts;
tss_=tss;
dx_=dx;
dy_=dy;
mp_=mp;
r0_=r0;

% calculation of angular velocity

omega=omeg;


figure(11)
plot(omega(:,1),omega(:,2),'m')
%pause


% calculation of angle: phi = integral omega*dt
[mo,no]=size(omega);
%for j=1:mo-1,
%zze(j)=trap(omega(1:j,1),omega(1:j,2));
%end
%figure
%plot(omega(1:mo-1),zze)

%%pause


zmax=trap(omega(:,1),omega(:,2));
fz=flipud(omega(:,2));
tz=flipud(omega(:,1));
zz(1)=zmax;
for j=2:mo-1
zz(j)=zz(j-1)-(fz(j-1)+fz(j))*(tz(j-1)-tz(j))/2;
end
sss=fliplr(zz);
ccc=[0 sss(1:mo-2)];


%figure
%plot(omega(1:mo-1),zze,omega(1:mo-1),ccc,'r')



figure(12)
plot(omega(1:mo-1,1),ccc,'m')
%pause



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



